from __future__ import print_function

import os.path
import logging
import lib.logs

import json
import base64
from email.mime.text import MIMEText
from email.message import EmailMessage
from google.auth.transport.requests import Request
from google.oauth2.credentials import Credentials
from google_auth_oauthlib.flow import InstalledAppFlow
from googleapiclient.discovery import build
from google.oauth2 import service_account
from googleapiclient.errors import HttpError
from google.auth import impersonated_credentials
log = logging.getLogger('lib.logs.' + __name__)
log.info("DBG: inside ahGogole")
class ahGoogle:

    
    
    
    def __init__(self):
        print('Email class instantiated')
        #Globals
        self.SERVICE_ACCOUNT_FILE = r'svc_acct_token_creator.json'
        self.SCOPES = ['https://www.googleapis.com/auth/gmail.send',
                        'https://www.googleapis.com/auth/admin.directory.user']
    log = logging.getLogger('lib.logs.' + __name__)
    
    def auth(self):
        creds = None
    
        credentials = service_account.Credentials.from_service_account_file(self.SERVICE_ACCOUNT_FILE, scopes=self.SCOPES)
        self._credentials = credentials
        #return credentials
        
    
    def authSimple(self):
        if os.path.exists('token.json'):
            log.info("Using credentials on file in token.json")
            creds = Credentials.from_authorized_user_file('token.json', SCOPES)
        if not creds or not creds.valid:
            if creds and creds.expired and creds.refresh_token:
                log.info("Refreshing token")
                creds.refresh(Request())
            else:
                log.info("Prompting User for new Creds")
                flow = InstalledAppFlow.from_client_secrets_file(
                    'client_secret.json', SCOPES)
                creds = flow.run_local_server(port=0)
            # Save the credentials for the next run
            with open('token.json', 'w') as token:
                token.write(creds.to_json())
            log.info(r"Saved new token and/or creds to token.json")
        return creds
    
    
    
    def create_message(self, sender, to, subject, message_text):
    
        #message = MIMEText(message_text)
        message = EmailMessage()
        message['To'] = to
        message['From'] = sender
        message['Subject'] = subject
        message.set_content(message_text)
        encoded = base64.urlsafe_b64encode(message.as_bytes())
        decoded = encoded.decode()
        return {'raw': decoded }
       
    def send(self, EMAIL_FROM, EMAIL_TO, EMAIL_SUBJECT, MESSAGE_BODY):
        #creds = self.auth()
        self._credentials
        delegated_credentials = creds.with_subject(EMAIL_FROM)
        message = self.create_message(EMAIL_FROM, EMAIL_TO, EMAIL_SUBJECT, MESSAGE_BODY)
        try:
            service = build('gmail', 'v1', credentials=delegated_credentials)
            message = (service.users().messages().send(userId=EMAIL_FROM, body=message)
                    .execute())
            print('Message Id: %s' % message['id'])
        





        except HttpError as error:
            # TODO(developer) - Handle errors from drive API.
            print(f'An error occurred: {error}')    
    
    def updatePhoto(self, pmail, photo):
        
        
        #creds = self.auth()
        #creds = self.authSimple()
        creds = self._credentials
        
        delegated_credentials = creds.with_subject('admin@yourdomain.com')
        
        #service = build('admin', 'directory_v1', credentials=creds)
        service = build('admin','directory_v1', credentials=delegated_credentials)
        
        #base64img = '/9j/4AAQSkZJRgABAQAAAQABAAD'
        image = photo.replace("/","_")
        image = image.replace("+","-")
        image = image.replace("=","")
        
        test = 'someone@yourdomain.com'
        
        #the picture
        userPhoto = {
            'primaryEmail': pmail,
            'kind': 'admin#directory#user#photo',
            #'photoData': str(byteImg),
            'photoData': image,
            'mimeType': 'JPEG'
        }
        
        #results = service.users().photos().update(userKey='someone@yourdomain', body=userPhoto)
        #log.info(f"I'm going to try to update {pmail} with {image[0:20]}")
        
        results = service.users().photos().update(userKey='{}'.format(pmail), body=userPhoto)
        
        log.info(type(results))
        #log.info(str(results))
        try:
            results.execute()
            
        except HttpError as error:
            # TODO(developer) - Handle errors from drive API.
            print(f'An error occurred: {error}') 
            log.info(f'\n***RETURNED FROM SERVER{error}\n***')