
import logging
import lib.logs
from lib.ahGoogle import ahGoogle
from lib.ahSoapSender import ahSoapSender
from lib.ahConfig import ahConfig
from datetime import datetime
import os


log = logging.getLogger('lib.logs.' + __name__)
#set up all globals
config_file_path = r"C:\Scripts\PROD\ah_Google_Provision\update_user_photos\config.txt"
config = ahConfig(config_file_path)
cfg = config.get_config_section('config')
now_date = datetime.today().strftime('%d%m%Y')
ahSS = ahSoapSender(cfg['username'],cfg['password'], cfg['endpoint'],cfg['singleendpoint'])
ahg = ahGoogle()
ahg.auth()

def main():
    


    log.info("**********************************\n*******__ PROGRAM INIT ___*****")
    
    #Get a list of all the active employees
    
    listOfEmployees = []
    listOfEmployees = ahSS.getListOfEmployees()
    filename = os.path.join(cfg['archive'], "allEmployees_{}.csv".format(now_date))
    
    #write the list to archive so I can use it later
    
    ###################
    # Comment out if you need to use the
    # archived list instead of report from
    # Workday
    
    with open(filename, 'w') as fp:
        for guy in listOfEmployees:
            fp.write(f'\n{guy}')
        fp.close()   
    '''
    ####################
    # Uncomment if you need to use the arvhiced 
    # list instead of getting
    # workers from workday. 
 
    listOfEmployees = []
    with open(filename, 'r') as fp:
        for guy in fp:
            listOfEmployees.append(guy[:-1])
    '''
    if(len(listOfEmployees)>0):
        log.info("Workday returned a list of {} employees.".format(len(listOfEmployees)))
        
        for guy in listOfEmployees:
            #look up a photo 
                guy = ahSS.getPerson(guy) 
                #log.info(f"DBG: Returned to program and guy is set to {guy.employeeid}")
                        
            #put the photo in Google
                try:
                    ahg.updatePhoto(guy.email,guy.photo)
                    log.info(f"Updated photo on Google for {guy.email}")
                except Exception as err:
                    log.critical("Failed at ~program line 63ish: {}".format(err))
        
    
    
    else:
        print("I didn't find any employees")
    
    
    
    
    

    

if __name__ == '__main__':
    main()